Bug 1278750 - Missing dependency on servicemix.bundles.reflections in drools-karaf-features
Missing dependency on servicemix.bundles.reflections in drools-karaf-features
Status: VERIFIED
Product: JBoss BRMS Platform 6
Classification: JBoss
Component: OptaPlanner (Show other bugs)
6.2.0
Unspecified Unspecified
medium Severity high
: CR1
: 6.2.0
Assigned To: Geoffrey De Smet
Lukáš Petrovický
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-11-06 05:54 EST by Jiri Petrlik
Modified: 2016-04-28 01:09 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jiri Petrlik 2015-11-06 05:54:51 EST
Description of problem:
Dependency on org.apache.servicemix.bundles/org.apache.servicemix.bundles.reflections is missing in optaplanner-engine feature. The problem appears only on JBoss Fuse 6.1. In Fuse 6.2 it works correctly, because Fuse 6.2 has bundles.reflections installed by default.

How reproducible:
Try to install optaplanner-engine in Fuse 6.1 (6.1.1.redhat-412).

Workaround:
Install reflections bundle to Fuse before optaplanner-engine.
$ osgi:install mvn:org.apache.servicemix.bundles/org.apache.servicemix.bundles.reflections/0.9.8_1
Comment 2 Geoffrey De Smet 2015-11-06 11:20:11 EST
I presume this is a matter of adding it here:

https://github.com/droolsjbpm/droolsjbpm-integration/blob/master/drools-osgi/drools-karaf-features/src/main/filtered-resources/repository/features.xml#L123

reflections is a library that OptaPlanner introduced recently, but it didn't got added in the features.xml (and it should)
Comment 3 Geoffrey De Smet 2015-11-06 11:50:52 EST
We need at least org.reflections 0.9.10, not 0.9.8_1. Is that available on servicemix?
Comment 4 Geoffrey De Smet 2015-11-06 11:52:14 EST
It seems they have 0.9.10_2 available:
http://mvnrepository.com/artifact/org.apache.servicemix.bundles/org.apache.servicemix.bundles.reflections

I 'll try to go with that.
Comment 5 Geoffrey De Smet 2015-11-06 12:02:36 EST
Fixed on 6.3.x:
  https://github.com/droolsjbpm/droolsjbpm-integration/commit/e6d3d83d1e07874a1d13455865e46bbee5c04b5d
And on master:
  https://github.com/droolsjbpm/droolsjbpm-integration/commit/4437eb82f22e43f7a6b834d259c4578a64d149d4


WARNING: There are no OSGi tests that check this feature in community, so this is basically a blind commit (for the optaplanner OSGi feature only)... not good. We really need some sort of basic OSGi coverage in the community too.
Comment 6 Geoffrey De Smet 2015-11-06 12:05:11 EST
Also note that before my commit, this community test was already failing (and it's still failing after my commit which is unrelated):

ests run: 10, Failures: 0, Errors: 1, Skipped: 0, Time elapsed: 34.661 sec <<< FAILURE! - in org.drools.karaf.itest.InstallFeaturesAbstractKarafIntegrationTest
testInstallFeature[5](org.drools.karaf.itest.InstallFeaturesAbstractKarafIntegrationTest)  Time elapsed: 3.438 sec  <<< ERROR!
java.io.IOException: Error resolving artifact org.kie:kie-aries-blueprint:jar:6.3.1-SNAPSHOT: Could not find artifact org.kie:kie-aries-blueprint:jar:6.3.1-SNAPSHOT
        at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:354)
        at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolveFile(AetherBasedResolver.java:312)
        at org.ops4j.pax.url.mvn.internal.AetherBasedResolver.resolve(AetherBasedResolver.java:296)
        at org.ops4j.pax.url.mvn.internal.Connection.getInputStream(Connection.java:131)
        at java.net.URL.openStream(URL.java:1038)
        at org.apache.karaf.features.internal.FeaturesServiceImpl.installBundleIfNeeded(FeaturesServiceImpl.java:864)
        at org.apache.karaf.features.internal.FeaturesServiceImpl.doInstallFeature(FeaturesServiceImpl.java:673)
        at org.apache.karaf.features.internal.FeaturesServiceImpl.doInstallFeatures(FeaturesServiceImpl.java:432)
        at org.apache.karaf.features.internal.FeaturesServiceImpl$1.call(FeaturesServiceImpl.java:402)
        at java.util.concurrent.FutureTask.run(FutureTask.java:266)
        at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)
        at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)
        at java.lang.Thread.run(Thread.java:745)
Comment 7 jvahala 2015-11-23 04:17:13 EST
No longer missing dependency. Verified

Note You need to log in before you can comment on or make changes to this bug.